#include <stdio.h>
#include <iostream.h>
#include <conio.h>

// modell ruber-beute-beziehungen

// erweitertes Lotka-Volterra-Modell

// Parameter des erweiterten ruber-beute-modells

float RDiff = 0.0  ; 	// differenz ruber in DeltaT
float BDiff = 0.0  ; 	// differenz beute in DeltaT
float R = 	  5.0  ;    // anzahl ruber
float B = 	 23.0  ;    // anzahl beute
float KR = 	 50.0  ;	// umwelttragfhigkeit ruber
float KB =	250.0  ;	// umwelttragfhigkeit beute
float d = 	  0.01 ;	// sterberate ruber, nicht abhngig 
float s = 	  0.05 ;	// sterberate beute, abhngig von anzahl R
float g = 	  0.01 ;	// wachstumsrate ruber
float f = 	  0.15  ;	// vermehrungsrate beute

// laufvariablen

int TMAX =	 80 ;
int AktT = 	  0 ;
int DeltaT =  1 ;
int j = 	  0 ;

// variablen ausgabe

char diagramm [30] ;


//simulation erweitertes lotka-volterra-modell

void main ()
{

	AktT = DeltaT ;

	while ( TMAX - AktT   > 0 )
	{

			// initialisiere earray

			for ( j = 0 ; j < 30 ; j++ ) 
			{
				diagramm [j] = ' ' ;
			}

			// vernderung der ruber-population


			BDiff = f * B - s * B * R - ((B * B) / KB) ;
			B = B + BDiff ;

			// vernderung der beute-population

			RDiff = g * B * R - d * R - ((R * R) / KR) ;
			R = R + RDiff ;
		
			// ausgabe

			diagramm [(int) R] = 'R' ;
			diagramm [(int) B] = 'B' ;			


			for ( j = 0 ; j < 25 ; j++ )
			{
				gotoxy ( AktT, 23-j) ;
				cout << diagramm [j] ;
			}

			getch ( ) ;

			// nchste Periode

			AktT  = AktT + DeltaT ;
            

	}

	getch () ;

}